package beamlinercp;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.ISelectionListener;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.actions.ActionFactory;
import org.eclipse.ui.plugin.AbstractUIPlugin;


public class NewSampleAction extends Action implements 
ISelectionListener, ActionFactory.IWorkbenchAction{
	
	private final IWorkbenchWindow window;
	public final static String ID = "beamlinercp.newsampleaction";
	private IStructuredSelection selection;

	public NewSampleAction(IWorkbenchWindow window)
	{
		this.window = window;
		setId(ID);
		setText("&New Sample");
		window.getSelectionService().addSelectionListener(this);
	
	}

	public void dispose()
	{
		window.getSelectionService().removeSelectionListener(this);
	}

	public void run()
	{

		NewSampleWizard wizard = new NewSampleWizard();

		
		wizard.init(window.getWorkbench(), selection);
		WizardDialog dialog = new WizardDialog(window.getShell(), wizard);
		dialog.open();
	}
	
	public void selectionChanged(IWorkbenchPart part, ISelection incoming)
	{
			setEnabled(true);	
	}
}
